* Congruence regressions. (4/18/2010); 
LIBNAME rawdata 'c:\Data\States';

DATA data1;
 SET rawdata.findat;

PROC SORT; BY policyname;
TITLE 'Table 1';
PROC UNIVARIATE; VAR opinionC; BY policyname;

PROC MEANS; VAR cong; BY policyname;
TITLE 'Figure 2';
PROC MEANS; VAR congV; BY policyname;
PROC MEANS; VAR congS; BY policyname;
PROC MEANS; VAR congSV; BY policyname;

* Initiatives and judges;
DATA; SET data1;
TITLE 'Table 2';
PROC SORT; BY init; PROC MEANS; VAR policy; BY init;
PROC SORT; BY init; PROC MEANS; VAR cong congV congS congSV; BY init;
PROC SORT; BY jtypeL; PROC MEANS; VAR policy; BY jtypeL;

PROC SORT; BY initC0; PROC MEANS; VAR policy; BY initC0; *Only constitutional initiative;
PROC SORT; BY initCS; PROC MEANS; VAR policy; BY initCS; *Constitutional + statutory;
PROC SORT; BY initS0; PROC MEANS; VAR policy; BY initS0; *Only statutory initiative;

* Initiatives and judges;
DATA; SET data1; *IF impute=1 THEN DELETE;
TITLE 'Table 3. Initiatives and Judges';
PROC LOGIST DESCENDING;
 MODEL policy = init opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9; *(1);
PROC LOGIST DESCENDING;
 MODEL policy = judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9; *(2);
PROC LOGIST DESCENDING;
 MODEL policy = init judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9; *(3);
PROC LOGIST DESCENDING;
 MODEL policy = initC initS0 judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9; *(4);
PROC LOGIST DESCENDING;
 MODEL policy = init jelect1 Jelect2 judgeL opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9; *(5);
* Estimated prob(1): Abortion consent DD1 opinionM=.749 (median);
* Estimated prob(2): Death penalty DD6 opinionM=.792 (median);
* Estimated prob(3): Gay marriage DD7 opinionM=.688;
* Estimated prob(4): Abortion public funding DD3 opinionM=.528;
* Estimated prob(5): School prayer DD8 opinionM=.885 (median);
* Estimated prob(6): English only DD4 opinionM=.703 (median);
* Estimated prob(7): Estate tax DD5 opinionM=.730 (median);
* Estimated prob(8): Term limits DD9 opinionM=.785; 
DATA; SET data1;
TITLE 'Predicted (Table 4)';
PROC LOGIST DESCENDING OUTEST=probs;
 MODEL policy = init judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9;
PROC PRINT DATA=probs;
DATA; SET probs;
 * (1) Abortion consent;
 XB1 = opinionM*(0.749) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd1 + intercept;
 phat1=1/(1+exp(-XB1));
 phatX1=phat1*(1-phat1);
 B1init=init*phatX1;
 B1judge1=judge1*phatX1;
 * (3) Public funding, abortion;
 XB3 = opinionM*(0.528) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd3 + intercept;
 phat3=1/(1+exp(-XB3));
 phatX3=phat3*(1-phat3);
 B3init=init*phatX3;
 B3judge1=judge1*phatX3;
 phat3I=1/(1+exp(-XB3-init));
 phat3J=1/(1+exp(-XB3-judge1));
 phat3IJ=1/(1+exp(-XB3-init-judge1));
 * (4) English only;
 XB4 = opinionM*(0.703) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd4 + intercept;
 phat4=1/(1+exp(-XB4));
 phatX4=phat4*(1-phat4);
 B4init=init*phatX4;
 B4judge1=judge1*phatX4;
 * (5) Estate tax; *Used this one for Table 5;
 XB5 = opinionM*(0.730) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd5 + intercept;
 phat5=1/(1+exp(-XB5)); *Predicted with init=0 and judge1=0;
 phatX5=phat5*(1-phat5);
 B5init=init*phatX5;
 B5judge1=judge1*phatX5;
 phat5I=1/(1+exp(-XB5-init)); *Predicted with init=1 and judge1=0;
 phat5J=1/(1+exp(-XB5-judge1)); *Predicted with init=0 and judge1=1;
 phat5IJ=1/(1+exp(-XB5-init-judge1)); *Predicted with init=1 and judge1=1;
 * (6) Death penalty;
 XB6 = opinionM*(0.792)+ lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd6 + intercept;
 XB6I = XB6 + init;
 XB6J = XB6 + judge1;
 XB6IJ = XB6 + init + judge1;
 phat6=1/(1+exp(-XB6));
 phat6I=1/(1+exp(-XB6I));
 phat6J=1/(1+exp(-XB6J));
 phat6IJ=1/(1+exp(-XB6IJ));
 phatX6=phat6*(1-phat6);
 B6init=init*phatX6;
 B6judge1=judge1*phatX6;
 * (7) Gay marriage;
 XB7 = opinionM*(0.688) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd7 + intercept;
 phat7=1/(1+exp(-XB7));
 phatX7=phat7*(1-phat7);
 B7init=init*phatX7;
 B7judge1=judge1*phatX7;
 * (8) School prayer;
 XB8 = opinionM*(.885) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd8 + intercept;
 phat8=1/(1+exp(-XB8));
 phatX8=phat5*(1-phat8);
 B8init=init*phatX8;
 B8judge1=judge1*phatX8;
 phat8I=1/(1+exp(-XB8-init));
 phat8J=1/(1+exp(-XB8-judge1));
 phat8IJ=1/(1+exp(-XB8-init-judge1));
 * (9) Term limits;
 XB9 = opinionM*(0.785) + lpop*(15.09) + edHS00*(0.85) + union00*(1.66) + dd9 + intercept;
 phat9=1/(1+exp(-XB9));
 phatX9=phat9*(1-phat9);
 B9init=init*phatX9;
 B9judge1=judge1*phatX9;
PROC PRINT; VAR phat1 B1init B1judge1 phat3 phat3I phat3J phat3IJ B3init B3judge1 phat4 B4init B4judge1 phat5 phat5I phat5J phat5IJ B5init B5judge1 
                phat6 phat6I phat6J phat6IJ B6init B6judge1 phat8 phat8I phat8J phat8IJ B8init B8judge1 phat9 B9init B9judge1;

* Election laws;
DATA; SET data1;
PROC MEANS;
 VAR limitC limitI limitCPAC CFcontri CFpubfin CFdisclo CFI primary2 indcomm accessF accessS recall;
TITLE 'Table 5. Election institutions summary';
PROC SORT; BY limitC; PROC MEANS; VAR cong; BY limitC;
PROC SORT; BY limitI; PROC MEANS; VAR cong; BY limitI;
PROC SORT; BY limitCPAC; PROC MEANS; VAR cong; BY limitCPAC;
PROC SORT; BY CFcontriB; PROC MEANS; VAR cong; BY CFcontriB;
PROC SORT; BY CFpubfinB; PROC MEANS; VAR cong; BY CFpubfinB;
PROC SORT; BY CFdiscloB; PROC MEANS; VAR cong; BY CFdiscloB;
PROC SORT; BY CFIB; PROC MEANS; VAR cong; BY CFIB;
PROC SORT; BY primary2; PROC MEANS; VAR cong; BY primary2;
PROC SORT; BY indcomm; PROC MEANS; VAR cong; BY indcomm;
PROC SORT; BY accessF; PROC MEANS; VAR cong; BY accessF;
PROC SORT; BY accessS; PROC MEANS; VAR cong; BY accessS;
PROC SORT; BY recall; PROC MEANS; VAR cong; BY recall;

* Election laws;
PROC LOGIST DESCENDING;
 MODEL policy = limitC limitI primary2 indcomm accessF accessS recall
                init judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9;
 TITLE 'Table 6. Election institutions regressions';
PROC LOGIST DESCENDING;
 MODEL policy = CFcontri CFpubfin CFdisclo primary2 indcomm accessF accessS recall
                init judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9;
PROC LOGIST DESCENDING;
 MODEL policy = CFI primary2 indcomm accessF accessS recall
                init judge1 opinionM lpop edHS00 south union00 dd1 dd2 dd3 dd4 dd5 dd6 dd7 dd8 dd9;

RUN;
